"""autogenerated by genmsg_py from TactileSensor.msg. Do not edit."""
import roslib.message
import struct

import schunk_sdh.msg
import std_msgs.msg

class TactileSensor(roslib.message.Message):
  _md5sum = "c6176a03c00cccf1b8efd3037de0d45d"
  _type = "schunk_sdh/TactileSensor"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#tactile sensor data in 2D grid
Header header
schunk_sdh/TactileMatrix[] tactile_matrix

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: schunk_sdh/TactileMatrix
uint32 matrix_id
int16 cells_x
int16 cells_y
int16[] tactile_array

"""
  __slots__ = ['header','tactile_matrix']
  _slot_types = ['Header','schunk_sdh/TactileMatrix[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,tactile_matrix
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(TactileSensor, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.tactile_matrix is None:
        self.tactile_matrix = []
    else:
      self.header = std_msgs.msg._Header.Header()
      self.tactile_matrix = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.tactile_matrix)
      buff.write(_struct_I.pack(length))
      for val1 in self.tactile_matrix:
        _x = val1
        buff.write(_struct_I2h.pack(_x.matrix_id, _x.cells_x, _x.cells_y))
        length = len(val1.tactile_array)
        buff.write(_struct_I.pack(length))
        pattern = '<%sh'%length
        buff.write(struct.pack(pattern, *val1.tactile_array))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tactile_matrix = []
      for i in range(0, length):
        val1 = schunk_sdh.msg.TactileMatrix()
        _x = val1
        start = end
        end += 8
        (_x.matrix_id, _x.cells_x, _x.cells_y,) = _struct_I2h.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sh'%length
        start = end
        end += struct.calcsize(pattern)
        val1.tactile_array = struct.unpack(pattern, str[start:end])
        self.tactile_matrix.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.tactile_matrix)
      buff.write(_struct_I.pack(length))
      for val1 in self.tactile_matrix:
        _x = val1
        buff.write(_struct_I2h.pack(_x.matrix_id, _x.cells_x, _x.cells_y))
        length = len(val1.tactile_array)
        buff.write(_struct_I.pack(length))
        pattern = '<%sh'%length
        buff.write(val1.tactile_array.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tactile_matrix = []
      for i in range(0, length):
        val1 = schunk_sdh.msg.TactileMatrix()
        _x = val1
        start = end
        end += 8
        (_x.matrix_id, _x.cells_x, _x.cells_y,) = _struct_I2h.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sh'%length
        start = end
        end += struct.calcsize(pattern)
        val1.tactile_array = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=length)
        self.tactile_matrix.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_I2h = struct.Struct("<I2h")
_struct_3I = struct.Struct("<3I")
